NMgcxplot<-function(ref.chrom=NULL,c2c=NULL,snp=NULL,qry.chrom=NULL,xlim=NULL,xat=5000,ref.name="REFERENCE",qry.name="QUERY",indel.size=100,indel.color=c(8,4),segment.color=1,snp.color=1,chunk.color=c(2,3,4))
{
   c2c = read.table(file=c2c)
   snp = read.table(file=snp)
   c2c_chrom   = subset(c2c, c2c$V1==ref.chrom)
   snp_chrom   = subset(snp, snp$V2==ref.chrom)
   if (is.null(xlim))
   {
      xlim=c(min(c2c_chrom[,2]),max(c2c_chrom[,3]))
   }
   nchunk      = dim(c2c_chrom)[1]
   chrom_start = c2c_chrom$V2[1]
   chrom_end   = c2c_chrom$V3[nchunk]
   # How many qry ?
   qry         = levels(factor(c2c_chrom$V7))
   nqry        = length(qry)
   qry_col     = rainbow(n=nqry*2)
   c2c_qry_col = array(0,nchunk)
   for(j in 1:nqry)
   {
      c2c_qry_col[which(c2c_chrom$V7==qry[j])]=qry_col[2*j]
   }
   plot(NA,NA,ylim=c(0,12),xlim=xlim,axes=F,main=ref.chrom, ylab="", xlab="Position (kb)")
   segments(xlim[1], 0, xlim[2], 0, col=segment.color)
   segments(xlim[1], 1, xlim[2], 1, col=segment.color)
   segments(xlim[1], 2, xlim[2], 2, col=segment.color)
   segments(xlim[1], 3, xlim[2], 3, col=segment.color)
   qend    = c2c_chrom$V2[1]
   qstart  = qend
   size    = 0
   old_qry = NULL
   for(j in 1:dim(c2c_chrom)[1])
   { 
      if (c2c_chrom$V4[j]=="c" && c2c_chrom$V5[j]=="+")
      {
	 chunk_color=chunk.color[1]
      }
      else if (c2c_chrom$V4[j]=="c" && c2c_chrom$V5[j]=="-")
      {
	 chunk_color=chunk.color[2]
      }
      else
      {
	 chunk_color=chunk.color[3]
      }
      if (j > 1 && old_qry$name != c2c_chrom$V7[j])
      {
	 #text(0.5*(old_qry$start+qend), 11.5, old_qry$ref.name, adj=0.5, cex=par("cex.lab"))
	 old_qry = list(name=c2c_chrom$V7[j],start=qend,ref.name=c2c_chrom$V7[j])
	 if (!is.null(qry.chrom))
	 {
	    old_qry$ref.name=as.character(subset(qry.chrom, qry.chrom$V2==c2c_chrom$V7[j])$V1)
	 }
      }
      if (j==1)
      {
	 old_qry = list(name=c2c_chrom$V7[j],start=qstart,ref.name=c2c_chrom$V7[j])
	 if (!is.null(qry.chrom))
	 {
	    old_qry$ref.name=as.character(subset(qry.chrom, qry.chrom$V2==c2c_chrom$V7[j])$V1)
	 }
      }
      if (c2c_chrom$V6[j]=="-")
      {
	 if (j>1)
	 {
	    rect(qend, 11, qend+size, 12, col=c2c_qry_col[j], border=NA) 
	 }
	 qstart = qend + size
	 size   = c2c_chrom$V3[j]-c2c_chrom$V2[j]+1
	 qend   = qend + size
	 if (c2c_chrom$V5[j]=="+")
	 {
	    polygon(x=c(c2c_chrom$V2[j],c2c_chrom$V3[j],qend,qstart,c2c_chrom$V2[j]),y=c(4,4,8,8,4),col=chunk_color, border=NA)
	 }
	 else
	 {
	    polygon(x=c(c2c_chrom$V2[j],c2c_chrom$V3[j],qstart,qend,c2c_chrom$V2[j]),y=c(4,4,8,8,4), col=chunk_color, border=NA)
	 }
	 rect(qstart, 11, qend, 12, col=c2c_qry_col[j], border=NA) 
      }
      else if (c2c_chrom$V6[j]=="d")
      {
	 size = abs(c2c_chrom$V10[j]-c2c_chrom$V9[j])+1
	 if (size > indel.size) indel_color = indel.color[2] 
	 else indel_color = indel.color[1]
	 rect(qstart, 9, qstart+size, 10, col=indel_color, border=indel_color)
	 rect(qstart, 11, qend, 12, col=c2c_qry_col[j], border=NA)
	 size=0 #because the position are | ref
      }
      else
      {
	 size = abs(c2c_chrom$V3[j]-c2c_chrom$V2[j])+1
	 if (size > indel.size) indel_color = indel.color[2]
	 else indel_color = indel.color[1]
	 rect(c2c_chrom$V2[j], 2, c2c_chrom$V3[j], 3, col=indel_color, border=indel_color)
      }
   }
   segments(snp_chrom$V4, 0, snp_chrom$V4, 1, col=snp.color)
   segments(chrom_start, 9, qend, 9, col=segment.color)
   segments(chrom_start, 10, qend, 10, col=segment.color)
   ##
   # x-axis
   ##
   x.pretty=c(seq(xlim[1],xlim[2],by=xat),xlim[2])
   x.label=sprintf("%.0f",x.pretty/1000)
   axis(1,at=x.pretty, x.label);
   par(las=1);
   axis(2,at=c(2.5,9.5),c(ref.name, qry.name),col=0);
}

NMsnpxplot<-function(alignment=NULL,polymorphism=NULL,chrom.sizes=NULL,window=1000,chromosomes=NULL,chrom.width=100,main="",space=50,xat.by=100,indel.size=1,insertion.col="darkblue",deletion.col="darkviolet",snp.colors=rev(heat.colors(n=20)),inversion.col="green",transloc.col="purple",legend.xy=c(1000000,1000),legend.width=200000)
{
   alignment=read.table(file=alignment)
   polymorphism=read.table(file=polymorphism)
   chrom.sizes=read.table(file=chrom.sizes)
   if (is.null(chromosomes))
   {
      chromosomes=as.character(chrom.sizes[,1])
   }
   NC=length(chromosomes)
   cs=array(0,NC)
   for(c in 1:NC)
   {
      cx=which(chrom.sizes[,1]==chromosomes[c])
      cs[c]=chrom.sizes[cx,2]
   }
   cx=sort(cs,index.return=TRUE)$ix
   xlim=c(0,max(cs))
   ylim=c(0,chrom.width*NC+space*(NC-1))
   plot(NA,xlim=xlim,ylim=ylim,xlab="Position",ylab="",main=main,axes=FALSE)
   y=0
   for(c in 1:NC)
   {
      cc=cx[c]
      chunks=subset(alignment,alignment[,1]==chromosomes[cc])
      poly=subset(polymorphism,polymorphism[,2]==chromosomes[cc])
      x0=0;x1=cs[cc]
      y0=y;y1=y+chrom.width
      # The chromosome
      rect(0,y0,x1,y1,col=8,border=8,lwd=par("lwd"))
      # The SNP density
      snp=subset(poly,poly[,3]=="snp")
      for(i in 1:dim(chunks)[1])
      {
         x_start=chunks[i,2]
	 x_end  =chunks[i,3]
	 snp.pos=type.convert(as.character(snp[,4]))
         chunk.snp=snp.pos[snp.pos>=x_start & snp.pos<=x_end]
         for(w in seq(x_start,x_end,by=window))
	 {
	    window.nsnp=sum(chunk.snp>=w & chunk.snp<=w+window)
	    if (window.nsnp >= length(snp.colors)) window.nsnp=length(snp.colors)-1
	    rect(w,y0,w+window,y1,col=snp.colors[window.nsnp+1],border=NA)
	 }
      }
      # The insertions/deletions
      insertions=subset(poly,poly[,3]=="ins")
      for(i in 1:dim(insertions)[1])
      {
         x_start=type.convert(as.character(insertions[i,4]))
	 x_end  =type.convert(as.character(insertions[i,5]))
	 if (x_end-x_start+1>=indel.size*1000)
	 {
            rect(x_start,y0,x_end,y1,col=insertion.col,border=NA)
	 }   
      }
      deletions=subset(poly,poly[,3]=="del")
      for(i in 1:dim(deletions)[1])
      {
         x_start=type.convert(as.character(deletions[i,4]))
	 x_end  =x_start+type.convert(as.character(deletions[i,9]))
	 if (x_end-x_start+1>=indel.size*1000)
	 {
	    segments(x_start,y1,x_start,y1+space/2,col=deletion.col,lwd=par("lwd")*2)
	    segments(x_start,y1+space/2,x_end,y1+space/2,col=deletion.col,lwd=par("lwd")*2)
	 }   
      }
      rect(x0,y0,x1,y1,col="#00000000",border="black",lwd=par("lwd"))
      # The chunks
      for(i in 1:dim(chunks)[1])
      {
         x_start=chunks[i,2]
	 x_end  =chunks[i,3]
         if (chunks[i,4]=="cis" && chunks[i,5]=="-")
	 {
	    brd.col=inversion.col
            rect(x_start,y0,x_end,y1,col="#00000000",border=brd.col,lwd=par("lwd")*2)
	 }
	 else if (chunks[i,4]=="trans")
	 {
	    brd.col=transloc.col
            rect(x_start,y0,x_end,y1,col="#00000000",border=brd.col,lwd=par("lwd")*2)
	 }
      }
      y=y1+space
   }
   # Legend
   x0=legend.xy[1]
   x1=x0+legend.width
   y0=legend.xy[2]
   y1=y0-chrom.width
   x=x0
   w=(x1-x0)/length(snp.colors)
   for(i in length(snp.colors):1)
   {
      rect(x,y0,x+w,y1,col=snp.colors[i],border=NA)
      x=x+w
   }
   rect(x0,y0,x1,y1,col="#00000000",border=1)
   text(x0,0.5*(y0+y1),"Low (0)",pos=2,cex=par("cex.lab"),font=par("font.lab"))
   text(x1,0.5*(y0+y1),sprintf("High (>=%d)",length(snp.colors)),pos=4,cex=par("cex.lab"),font=par("font.lab"))
   text(0.5*(x1+x0),y0,"SNP Density",pos=3,cex=par("cex.lab"),font=par("font.lab"))
   y0=y1-2*chrom.width
   y1=y0-chrom.width
   rect(x0,y0,x0+legend.width/4,y1,col=insertion.col,border=insertion.col)
   text(x0+legend.width/4,0.5*(y1+y0),"Insertion in BY",pos=4,cex=par("cex.lab"),font=par("font.lab"),col=insertion.col)
   y0=y1-space
   y1=y0-chrom.width
   segments(x0,y0,x0,y1,col=deletion.col,lwd=par("lwd")*3)
   segments(x0,y0,x0+legend.width/4,y0,col=deletion.col,lwd=par("lwd")*3)
   text(x0+legend.width/4,0.5*(y1+y0),"Insertion in RM",pos=4,cex=par("cex.lab"),font=par("font.lab"),col=deletion.col)
   y0=y1-space
   y1=y0-chrom.width
   rect(x0,y0,x0+legend.width/4,y1,col=0,border=inversion.col,lwd=par("lwd")*3)
   text(x0+legend.width/4,0.5*(y1+y0),"Inversion",pos=4,cex=par("cex.lab"),font=par("font.lab"),col=inversion.col)
   y0=y1-space
   y1=y0-chrom.width
   rect(x0,y0,x0+legend.width/4,y1,col=0,border=transloc.col,lwd=par("lwd")*3)
   text(x0+legend.width/4,0.5*(y1+y0),"Translocation",pos=4,cex=par("cex.lab"),font=par("font.lab"),col=transloc.col)
   # Axes
   axis(2,at=seq(0,ylim[2],by=(chrom.width+space))+chrom.width/2,chromosomes[cx],lty=0)
   axis(1,at=seq(0,xlim[2],by=xat.by*1000),paste(seq(0,xlim[2],by=xat.by*1000)/1000,"kb",sep=""),hadj=0.5,padj=1,lwd=par("lwd"))
}
