
NMt2featcisplot<-function(file=NULL,data=NULL,width=2500,height=2000,cex.pch=1,panel.ratio=c(0.8,0.2),xout.by=500,xin.by=20,boudary.names=c("TSS","TES"),main="",col="darkolivegreen3",xlim=c(-2500,2500),gene.color="darkred")
{
   if (!is.null(file))
   {
      data=list(cis.profile=list(read.table(file)),cis.name=list(main),cis.color=col)
   }
   layout(matrix(1:2,nrow=2,ncol=1),widths=width,heights=panel.ratio*height,respect=TRUE)
   mar=par("mar")
   ##
   # Default X-axis parameters
   ##
   N=length(data$cis.profile)
   xmin=array(0,N)
   xmax=array(0,N)
   featStart=array(0,N)
   featEnd=array(0,N)
   for(i in 1:N)
   {
     y=data$cis.profile[[i]]
     featStart[i]=y[which(y[,1]=="i")[1],5]
     featEnd[i]=y[which(y[,1]=="d")[1]-1,6]
     xmin[i]=y[1,5]
     xmax[i]=y[dim(snep)[1],6]
   }
   if (length(unique(featStart))!=1)
   {
     
   }
   xrange=c(min(xmin),max(xmax))
   if (is.null(xlim)) xlim=xrange
   else
   {
      xlim[1]=featStart+xlim[1]
      xlim[2]=featEnd+xlim[2]
   }
   X=(snep[,5]+snep[,6])/2
   Xi=X[snep[,1]=="i"]
   Xu=X[snep[,1]=="u"]
   Xd=X[snep[,1]=="d"]
   ##
   # Acetylation LogRatio Profile
   ##
   BY=by_ach[,7]/by_ach[,9]
   RM=rm_ach[,7]/rm_ach[,9]
   ylim=range(c(BY,RM))
   plot(NA,xlim=xlim,ylim=ylim,axes=FALSE,xlab="",ylab="Avg. Log Ratio (CHIP/ALL)",main="")
   abline(v=c(featStart,featEnd),col=gene.color,lty=3)
   lines(X,BY,type="l",lwd=par("lwd")*3,col=by.col)
   lines(X,RM,type="l",lwd=par("lwd")*3,col=rm.col)
   axis(2,lwd=par("lwd"))
   legend("topleft",c("BY","RM"),col=c(by.col,rm.col),lwd=par("lwd")*3,bty="n",cex=par("cex.lab"))
   ## 
   # SNEP Occupancy
   ##
   BY=snep[,8]/snep[,7]
   RM=snep[,9]/snep[,7]
   ylim=range(c(BY,RM))
   plot(NA,xlim=xlim,ylim=ylim,axes=FALSE,xlab="",ylab="Pr ( SNEP )",main="")
   abline(v=c(featStart,featEnd),col=gene.color,lty=3) 
   lines(X,BY,type="l",lwd=par("lwd")*3,col=by.col)
   lines(X,RM,type="l",lwd=par("lwd")*3,col=rm.col)
   axis(2,lwd=par("lwd"))
   legend("topleft",c("BY","RM"),col=c(by.col,rm.col),lwd=par("lwd")*3,bty="n",cex=par("cex.lab"))
   ##
   # SNEP Occupancy w.r.t Gene expression
   ##
   #POS=(snep_exp[,12]+snep_exp[,14])/(snep_exp[,8]+snep_exp[,9])
   #NEG=(snep_exp[,11]+snep_exp[,15])/(snep_exp[,8]+snep_exp[,9])
   #ZERO=(snep_exp[,10]+snep_exp[,13])/snep_exp[,7]
   #CONTROL=(snep_exp[,10]+snep_exp[,13])/snep_exp[,7]
   #ylim=range(c(POS,NEG,ZERO))
   #plot(NA,xlim=xlim,ylim=ylim,axes=FALSE,xlab="",ylab="Pr ( SNEP | Exp. Diff. )",main="")
   #lines(X,BOTH,type="l",lwd=par("lwd")*1.5,col=8)
   #lines(X,POS,type="l",lwd=par("lwd")*3,col="red")
   #lines(X,NEG,type="l",lwd=par("lwd")*3,col="green")
   #lines(X,ZERO,type="l",lwd=par("lwd")*3,col="black")
   #axis(2,lwd=par("lwd"))
   #abline(v=c(featStart,featEnd),col=col.gene,lty=3) 
   #legend("topright",c("(SNEP) * (Exp. Diff.) > 0","(SNEP) * (Exp. Diff.) < 0","(SNEP) | (Exp. Diff.) = 0"),col=c("red","green","black"),lwd=par("lwd")*3,bty="n",cex=par("cex.lab"))
   ## 
   # Schematic feature
   ##
   par(mar=c(mar[1],mar[2],mar[3]/4,mar[4]))
   plot(NA,xlim=xlim,ylim=c(-1,1),axes=FALSE,xlab="Position",ylab="",main="")
   segments(xlim[1],0,xlim[2],0,col="grey",lwd=par("lwd")*4)
   rect(featStart,-0.5,featEnd, 0.5,col=gene.color)
   axis(1,at=xlim,labels=FALSE)
   axis(1,at=seq(xlim[1], featStart-xout.by, by=xout.by), paste(seq(xlim[1]-featStart, -xout.by, by=xout.by)/1000,"kb",sep=""), hadj=0.5, padj=1, lwd=par("lwd"))
   axis(1,at=c(featStart,featEnd),boudary.names,hadj=0.5, padj=1, lwd=par("lwd"),font=2)
   n = 100/xin.by
   w = (featEnd-featStart)/n
   axis(1,at=seq(featStart+w,featEnd-w,by=w),paste(seq(xin.by,100-xin.by,by=xin.by),"%",sep=""),hadj=0.5, padj=1, lwd=par("lwd"))
   axis(1,at=seq(featEnd+xout.by, xlim[2], by=xout.by), paste(seq(xout.by, xlim[2]-featEnd, by=xout.by)/1000,"kb",sep=""), hadj=0.5, padj=1, lwd=par("lwd"))
   par(mar=mar)
}


NMt2featplot<-function(file=NULL,type="start",width=1000,height=1500,panel.ratio=c(0.30,0.70),color.in="darkolivegreen3",color.out="black",arrow.size=100,ylim=NULL,xat=NULL,main=NULL,boundary.name="Boundary",ylab="Probability")
{
   data=read.table(file=file)
   layout(matrix(c(1,2),nrow=2,ncol=1,byrow=FALSE),widths=width,height=panel.ratio*height,respect=TRUE)
   if (type=="start") NMt2featplotS(data,color.in,color.out,arrow.size,cex.point,ylim,xat,main,boundary.name,ylab)
   else if (type=="end") NMt2featplotE(data,color.in,color.out,arrow.size,cex.point,ylim,xat,main,boundary.name,ylab)
   else print("Unknown type")
}

NMt2featplotS<-function(TSS,color.in,color.out,arrow.size,cex.point,ylim,xat,main,boundary.name,ylab)
{
   XStart  = TSS[,3]
   XEnd    = TSS[,4]
   Xn      = length(XStart)
   XRange = c(XStart[1],XEnd[Xn])
   # TSS schematic gene
   plot(NA,xlim=XRange,ylim=c(-1,1),xlab="",ylab="",main=boundary.name,axes=FALSE)
   for(i in 1:Xn)
   {
      if (XEnd[i] <= 0)
         rect(XStart[i],-0.25,XEnd[i],0.25,col=color.out,border=color.out)
      else
         rect(XStart[i],-0.75,XEnd[i],0.75,col=color.in,border=color.in)
   }
   polygon(x=c(0,arrow.size,0),y=c(0.75,0,-0.75),col="white",border=NA)
   rect(0,0.75,XRange[2],-0.75,col="#00000000",border=1)
   axis(2,at=0,"5'",col=0)
   axis(4,at=0,"3'",col=0)
   mar=par("mar")
   #opar=par(mar=mar.panel)
   par(yaxs="i")
   Y = TSS[,5]/TSS[,6]
   if (is.null(ylim)) {ylim=range(Y)}
   par(adj=0)
   #par(mar=mar.main)
   plot(NA,xlim=XRange,ylim=ylim,xlab="",ylab="",main=main,axes=FALSE)
   par(new=TRUE)
   par(adj=0.5)
   #par(mar=mar.panel)
   plot(0.5*(XStart+XEnd),Y,xlim=XRange,ylim=ylim,xlab="",ylab=ylab,main=main,axes=FALSE,type="l",col=0)
   par(new=FALSE)
   xx=XStart[XEnd<=0]
   yy=Y[XEnd<=0]
   lines(xx,yy, col=color.out, lwd=par("lwd")*2)
   xx=XStart[XEnd>=0]
   yy=Y[XEnd>=0]
   lines(xx,yy, col=color.in, lwd=par("lwd")*2)
   if (is.null(xat))
   {
      xat=pretty(xx)
   }
   x.lab=(xat/1000)
   x.lab[x.lab!=0]=paste(x.lab[x.lab!=0],"kb",sep="")
   x.lab[x.lab==0]=boundary.name
   axis(1,at=xat,x.lab,hadj=0.5,padj=1,lwd=par("lwd"))
   axis(2,lwd=par("lwd"))
   box(bty="u")
   #par(opar)
}

NMt2featplotE<-function(TES,color.in,color.out,arrow.size,cex.point,ylim,xat,main,boundary.name,ylab)
{
   XStart  = TES[,3]
   XEnd    = TES[,4]
   Xn      = length(XStart)
   XRange = c(XStart[1],XEnd[Xn])
   plot(NA,xlim=XRange,ylim=c(-1,1),xlab="",ylab="",main=boundary.name,axes=FALSE)
   for(i in 1:Xn)
   {
      if (XEnd[i] <= 0)
         rect(XStart[i],-0.75,XEnd[i],0.75,col=color.in,border=color.in)
      else
         rect(XStart[i],-0.25,XEnd[i],0.25,col=color.out,border=color.out)
   }
   rect(XRange[1],0.75,0,-0.75,col="#00000000",border=1)
   axis(2,at=0,"5'",col=0)
   axis(4,at=0,"3'",col=0)
   mar=par("mar")
   #mar.panel=c(mar[4],mar[2],mar[3],mar[4])
   #opar=par(mar=mar.panel)
   par(yaxs="i")
   X = 0.5*(XStart+XEnd)
   Y = TES[,5]/TES[,6]
   if (is.null(ylim)) {ylim=range(Y)}
   plot(0.5*(XStart+XEnd),Y,xlim=XRange,ylim=ylim,xlab="",ylab=ylab,main=main,axes=FALSE,type="l",col=0)
   xx=XStart[XEnd<=0]
   yy=Y[XEnd<=0]
   lines(xx,yy, col=color.in, lwd=par("lwd")*2)
   xx=XStart[XEnd>=0]
   yy=Y[XEnd>=0]
   lines(xx,yy, col=color.out, lwd=par("lwd")*2)
   if (is.null(xat))
   {
      xat=pretty(xx)
   }
   x.lab=(xat/1000)
   x.lab[x.lab!=0]=paste(x.lab[x.lab!=0],"kb",sep="")
   x.lab[x.lab==0]=boundary.name
   axis(1,at=xat,x.lab,hadj=0.5,padj=1,lwd=par("lwd"))
   axis(2,lwd=par("lwd"))
   box(bty="u")
}
