/*  
 *  header.c
 * 
 *  $Author: gael $, $Date: 2008-09-15 12:33:00 $, $Version$
 *
 *  NucleoMiner : a C package for nucleosome mapping and SNEP detection.
 *
 *  Reference:  Nagarajan et al. PLoS Genetics 2010, 6(4): e1000913. Natural Single-Nucleosome Epi-Polymorphisms in Yeast
 * 
 *  Copyright (C) 2010  Jean-Baptiste Veyrieras, Gael Yvert, CNRS/ENS-Lyon, France.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA * 
 */

static int
print_header (gdl_string * program)
{
    printf("%s - version %s\n\n", program, NUCLEO_MINER_VERSION);
    printf("Copyright (C) 2008  Jean-Baptiste Veyrieras, Gaël Yvert (INRA, ENS-Lyon)\n");
    printf("%s comes with ABSOLUTELY NO WARRANTY.\n", program);
    printf("This is free software, and you are welcome\n");
    printf("to redistribute it under certain conditions.\n");
    return 0;
}
